// MPDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MP.h"
#include "MPDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString gstr;

void BF (char *x, int m, char *y, int n);
void BF2(char *x, int m, char *y, int n); 
void AUT(char *x, int m, char *y, int n); 
void KR (char *x, int m, char *y, int n);
void NSN(char *x, int m, char *y, int n);
void QS (char *x, int m, char *y, int n);
void MP (char *x, int m, char *y, int n);
void SO (char *x, int m, char *y, int n);

void OUTPUT(unsigned long i)
{
	char buf[50];
	sprintf(buf,"%10d ",i);
	gstr += buf;
}

/*
7990967 BF  [203]   1935868 BF  [ 47]
7990967 BF2 [281]   1935868 BF2 [125]
7990967 KR  [172]   1935868 KR  [ 62]
7990967 NSN [ 94]   1935868 NSN [ 32]
7990967 MP  [156]   1935868 MP  [ 46]
7990967 AUT [125]   1935868 AUT [ 47]
7990967 QS  [ 31]   1935868 QS  [  0]
7990967 SO  [109]   1935868 SO  [ 47]
QS NSN SO AUT MP KR BF BF2
*/

void Test()
{
	char pFind[] = "2+2I2S2]2";
	char fn[]    = "d:/QtGui4.dll.SAFE";
	char tmp[50];
	int iLen = strlen(pFind);
	
	FILE *in = fopen(fn,"rb");
	if(!in) return;
	fseek(in,0L,SEEK_END);
	long size = ftell(in);
	fseek(in,0L,SEEK_SET);
	char *pData = (char*)malloc(size);
	fread(pData,size,1,in);
	fclose(in);
	
	long time[20];
	//pFind,10,pData,size
	//*
	//MessageBox(0,"start","test",0);
	Sleep(500);

	time[0]= GetTickCount();
	BF(pFind,iLen,pData,size);
	time[1]= GetTickCount();
	sprintf(tmp,"BF  [%3ld]\r\n",time[1]-time[0]);
	gstr += tmp;

	time[2]= GetTickCount();
	BF2(pFind,iLen,pData,size);
	time[3]= GetTickCount();
	sprintf(tmp,"BF2 [%3ld]\r\n",time[3]-time[2]);
	gstr += tmp;

	time[4]= GetTickCount();
	KR(pFind,iLen,pData,size);
	time[5]= GetTickCount();
	sprintf(tmp,"KR  [%3ld]\r\n",time[5]-time[4]);
	gstr += tmp;

	time[6]= GetTickCount();
	NSN(pFind,iLen,pData,size);
	time[7]= GetTickCount();
	sprintf(tmp,"NSN [%3ld]\r\n",time[7]-time[6]);
	gstr += tmp;

	time[8]= GetTickCount();
	MP(pFind,iLen,pData,size);
	time[9]= GetTickCount();
	sprintf(tmp,"MP  [%3ld]\r\n",time[9]-time[8]);
	gstr += tmp;

	time[10]= GetTickCount();
	AUT(pFind,iLen,pData,size);
	time[11]= GetTickCount();
	sprintf(tmp,"AUT [%3ld]\r\n",time[11]-time[10]);
	gstr += tmp;

	time[12]= GetTickCount();
	QS(pFind,iLen,pData,size);
	time[13]= GetTickCount();
	sprintf(tmp,"QS  [%3ld]\r\n",time[13]-time[12]);
	gstr += tmp;

	time[14]= GetTickCount();
	SO(pFind,iLen,pData,size);
	time[15]= GetTickCount();
	sprintf(tmp,"SO  [%3ld]\r\n",time[15]-time[14]);
	gstr += tmp;
	
	//*/
	free(pData);
}

#define ASIZE 256

////////////////////////////////////////////////////////////////////////////
//    BF
////////////////////////////////////////////////////////////////////////////
void BF(char *x, int m, char *y, int n) 
{
	register int i, j;
	/* Searching */
	for (j = 0; j <= n - m; ++j) {
		for (i = 0; i < m && x[i] == y[i + j]; ++i);
		if (i >= m)
			OUTPUT(j);
	}
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//    BF2 memcmp
////////////////////////////////////////////////////////////////////////////
void BF2(char *x, int m, char *y, int n) 
{
	register char *yb;
	/* Searching */ 
	//for (yb = y; *y != EOS; ++y)
	for (yb = y; y-yb<n; ++y)
		if (memcmp(x, y, m) == 0){
			OUTPUT(y - yb);
			break;
		}
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//    AUT
////////////////////////////////////////////////////////////////////////////
int preAut(const char *x, int m, int* aut) 
{
	register int i, state, target, old;
	for (state = 0, i = 0; i < m; ++i) {
		target = i + 1;
		old = aut[state * ASIZE + x[i]];
		aut[state * ASIZE + x[i]] = target;
		memcpy(aut + target * ASIZE, aut + old * ASIZE, ASIZE*sizeof(int));
		state = target;
	}
	return state;
}

void AUT(char *x, int m, char *y, int n) 
{
	register int j, state;
	/* Preprocessing */
	register int *aut = (int*)calloc((m+1)*ASIZE, sizeof(int));
	register int Terminal = preAut(x, m, aut);
	/* Searching */
	for (state = 0, j = 0; j < n; ++j) {
		state = aut[state*ASIZE+(unsigned char)y[j]];
		if (state == Terminal)
			OUTPUT(j - m + 1);
	}
	free(aut);
}
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//    KR
////////////////////////////////////////////////////////////////////////////
#define REHASH(a, b, h) ((((h) - (a)*d) << 1) + (b))
void KR(char *x, int m, char *y, int n) 
{
	register int d, hx, hy, i, j;
	/* Preprocessing */
	/* computes d = 2^(m-1) with
	the left-shift operator */
	for (d = i = 1; i < m; ++i)
		d = (d<<1);
    for (hy = hx = i = 0; i < m; ++i) {
		hx = ((hx<<1) + x[i]);
		hy = ((hy<<1) + y[i]);
    }
    /* Searching */
    j = 0;
    while (j <= n-m) {
		if (hx == hy && memcmp(x, y + j, m) == 0)
			OUTPUT(j);
		hy = REHASH(y[j], y[j + m], hy);
		++j;
    }
}  
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//    Shift Or
////////////////////////////////////////////////////////////////////////////
#define WORDSIZE sizeof(int)*8
//#define ASIZE 256
unsigned int preSo(char *x, int m, unsigned int S[]) 
{ 
    register unsigned int j, lim; 
    register int i; 
	for (i = 0; i < ASIZE; ++i) 
		S[i] = ~0; 
	for (lim = i = 0, j = 1; i < m; ++i, j <<= 1) { 
		S[(unsigned char)x[i]] &= ~j; 
	}
    lim = (((unsigned int)1)<<(m-1)) -1;
	lim = ~(lim); 
	return(lim);
}

void SO (char *x, int m, char *y, int n)
{
	register unsigned int lim, state; 
	register unsigned int S[ASIZE];
	register int j;
    register unsigned char* text = (unsigned char*)y;
	if (m > WORDSIZE) 
		TRACE("SO: Use pattern size <= word size"); 
	/* Preprocessing */ 
	lim = preSo(x, m, S); 
	/* Searching */ 
	for (state = ~(unsigned int)0, j = 0; j < n; ++j) { 
		state = (state<<1) | S[text[j]]; 
		if (state < lim) 
			OUTPUT(j - m + 1); 
	}
} 
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
//    Not So Naive
/////////////////////////////////////////////////////////////////////////////
void NSN(char *x, int m, char *y, int n) 
{
	register int j, k, ell;
	/* Preprocessing */
	if (x[0] == x[1]) {
		k = 2;
		ell = 1;
	}
	else {
		k = 1;
		ell = 2;
	}
	/* Searching */
	j = 0;
	while (j <= n - m)
		if (x[1] != y[j + 1])
			j += k;
		else {
			if (memcmp(x + 2, y + j + 2, m - 2) == 0 &&	x[0] == y[j])
				OUTPUT(j);
			j += ell;
		}
}
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//   Quick Search
/////////////////////////////////////////////////////////////////////////////
//#define ASIZE 256
void preQsBc(char *pat,int m,int qsBc[])
{
	register int i;
	for (i=0;i<ASIZE;++i)
		qsBc[i]=m+1;
	for (i=0;i<m;++i)
		qsBc[(unsigned char)pat[i]]=m-i;
}

void QS(char *x, int m,char * y,int n)
{
	register int j,qsBc[ASIZE];
	register unsigned char *text,*pat;
	text = (unsigned char*)y;
	pat = (unsigned char*)x;
	/* preprocessing */
	preQsBc((char*)pat,m,qsBc);
	/* Searching */
	j=0;
	while (j<=n-m)
	{
		if (memcmp(pat,text+j,m)==0)
			OUTPUT(j);
		j+=qsBc[text[j+m]]; //shift
	}
}
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
//            MP/KMP
/////////////////////////////////////////////////////////////////////////////
//#define ASIZE 256
void preMp(char *x, int m, int Next[]) 
{
	register int i, j;
	i = 0;
	j = Next[0] = -1;
	while (i < m) {
		while (j > -1 && x[i] != x[j])
            j = Next[j];
		i++;
		j++;
		// KMP
		//if (x[i] == x[j])
		//   Next[i] = Next[j];
		//else
		Next[i] = j;
	}
}

void MP(char *x, int m, char *y, int n) 
{
	register int i, j, Next[ASIZE];
	/* Preprocessing */
	preMp(x, m, Next);
	/* Searching */
	i = j = 0;
	while (j < n) {
		while (i > -1 && x[i] != y[j])
			i = Next[i];
		i++;
		j++;
		if (i >= m) {
			OUTPUT(j - i);
			i = Next[i];
		}
	}
}
/////////////////////////////////////////////////////////////////////////////

/////////////////////////////////////////////////////////////////////////////
// CMPDlg dialog

CMPDlg::CMPDlg(CWnd* pParent /*=NULL*/)
: CDialog(CMPDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMPDlg)
	// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	//Test();Test();Test();Test();Test();
	//Test();
	//exit(0);
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMPDlg)
	// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMPDlg, CDialog)
//{{AFX_MSG_MAP(CMPDlg)
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMPDlg message handlers

BOOL CMPDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMPDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMPDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMPDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CMPDlg::OnOK() 
{
	// TODO: Add extra validation here
	gstr = "";
	GetDlgItem(IDOK)->EnableWindow(0);
	Test();
	GetDlgItem(IDOK)->EnableWindow(1);
	GetDlgItem(IDC_EDIT1)->SetWindowText(gstr);
	//CDialog::OnOK();
}
